<?php

/**
 * Table tl_css_helper_style
 */
$GLOBALS['TL_DCA']['tl_css_helper_style'] = array
(
    // Config
    'config'   => array
    (
        'dataContainer' => 'Table',
        'ptable' => 'tl_css_helper_set',
        'enableVersioning' => true,
        'sql' => array
            (
            'keys' => array
                (
                'id' => 'primary',
                'pid' => 'index'
            )
        )
    ),
    // List
    'list' => array
    ( 
        'sorting' => array
        (
            'mode' => 4,
            'fields' => array('pid ASC'),
            'headerFields' => array('title'),
            'panelLayout' => 'filter;sort,search,limit',
            'child_record_callback' => array('tl_css_helper_style', 'listArticles'),
            'child_record_class' => 'no_padding',
            'disableGrouping' => true
        ),
        'global_operations' => array
        (
            'all' => array
            (
                'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
                'href'                => 'act=select',
                'class'               => 'header_edit_all',
                'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'
            )
        ),
        'operations' => array
        (
            'edit' => array
            (
                'label'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['edit'],
                'href'                => 'act=edit',
                'icon'                => 'edit.gif'
            ),
            'copy'   => array
            (
                'label'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['copy'],
                'href'                => 'act=copy',
                'icon'                => 'copy.gif',
            ),
            'delete' => array
            (
                'label'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['delete'],
                'href'                => 'act=delete',
                'icon'                => 'delete.gif',
                'attributes'          => 'onclick="if(!confirm(\'' . ($GLOBALS['TL_LANG']['MSC']['deleteConfirm'] ?? null) . '\'))return false;Backend.getScrollOffset()"'
            ),
            'toggle' => array
            (
                'icon'                => 'visible.svg',
                'attributes'          => 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleVisibility(this,%s)"',
                'button_callback'     => array('tl_css_helper_style', 'toggleIcon')
            ),
            'show' => array
            (
                'label'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['show'],
                'href'                => 'act=show',
                'icon'                => 'show.gif'
            )
        )
    ),
    // Palettes
    'palettes' => array
    (
        '__selector__' => array('inherit'),
        'default' => '{style_legend},title,cssClasses,description;{expert_legend},inherit,disableInArticle,disableInContent,disableInCalendarEvent,disableInForm,disableInFormField,disableInLayout,disableInModule,disableInNews,disableInPage,published',
        'custom' => '{style_legend},title,cssClasses,description;{expert_legend},inherit,elements,modules,disableInArticle,disableInContent,disableInCalendarEvent,disableInForm,disableInFormField,disableInLayout,disableInModule,disableInNews,disableInPage,published'

    ),
    // Fields
    'fields'   => array
    (
        'id' => array
        (
            'sql' => "int(10) unsigned NOT NULL auto_increment"
        ),
        'pid' => array
            (
            'foreignKey' => 'tl_css_helper_set.id',
            'sql' => "int(10) unsigned NOT NULL default '0'",
            'relation' => array('type' => 'belongsTo', 'load' => 'eager')
        ),
        'tstamp' => array
        (
            'sql'                     => "int(10) unsigned NOT NULL default '0'"
        ),
        'title' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['title'],
            'exclude'                 => true,
            'search'                  => true,
            'inputType'               => 'text',
            'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>'w50'),
            'sql'                     => "varchar(255) NOT NULL default ''"
        ),
        'cssClasses' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['cssClasses'],
            'exclude'                 => true,
            'inputType'               => 'text',
            'eval'                    => array('mandatory'=>true, 'maxlength'=>255, 'rgxp'=>'alphanumeric', 'tl_class'=>'w50'),
            'sql'                     => "varchar(255) NOT NULL default ''"
        ),
        'description' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['description'],
            'exclude'                 => true,
            'search'                  => true,
            'inputType'               => 'textarea',
            'eval'                    => array('mandatory'=>false, 'rte'=>'tinyMCE', 'helpwizard'=>true , 'tl_class'=>'clr'),
            'explanation'             => 'insertTags',
            'sql'                     => "mediumtext NULL"
        ),
        'inherit' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['inherit'],
            'exclude'                 => true,
            'inputType'               => 'radio',
            'options'                 => array('all', 'custom'),
            'reference'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['inherit'],
            'eval'                    => array('submitOnChange'=>true),
            'sql'                     => "varchar(12) NOT NULL default 'all'"
        ),
        'elements' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['elements'],
            'exclude'                 => true,
            'filter'                  => true,
            'inputType'               => 'checkbox',
            'options_callback'        => array('tl_css_helper_style', 'getContentElements'),
            'reference'               => &$GLOBALS['TL_LANG']['CTE'],
            'eval'                    => array('multiple'=>true),
            'sql'                     => "blob NULL"
        ),
        'modules' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['modules'],
            'exclude'                 => true,
            'inputType'               => 'checkbox',
            'options_callback'        => array('tl_css_helper_style', 'getModules'),
            'reference'               => &$GLOBALS['TL_LANG']['tl_css_helper_style']['modules'],
            'eval'                    => array('multiple'=>true),
            'sql'                     => "blob NULL"
        ),
        'published' => array
        (
            'label'                   => &$GLOBALS['TL_LANG']['tl_css_helper_style']['published'],
            'exclude'                 => true,
            'filter'                  => true,
            'inputType'               => 'checkbox',
            'sql'                     => "char(1) NOT NULL default '1'"
        ),
    )
);


/**
 * Class tl_css_helper_style
 */
class tl_css_helper_style extends Backend {

    /**
     * Import the back end user object
     */
    public function __construct()
    {
        parent::__construct();
        $this->import('Contao\BackendUser', 'User');
    }
    
    /**
     * Add the type of input field
     * @param array
     * @return string
     */
    public function showPreview($arrRow) {

        $period = "";
        if ($arrRow['start']) {
            $period .= '<span class="start">Start: ' . date("d-m-Y H:i",$arrRow['start']) . '</span>';
        }
        if ($arrRow['stop']) {
            $period .= '<span class="stop">Stop: ' . date("d-m-Y H:i",$arrRow['stop']) . '</span>';
        }

        return '<div class="tl_content_left tl_css_helper_style">' . $arrRow['title'] . '<br><span class="period">'.$period.'</span></div>';
    }

    /**
     * Return the "toggle visibility" button
     *
     * @param array  $row
     * @param string $href
     * @param string $label
     * @param string $title
     * @param string $icon
     * @param string $attributes
     *
     * @return string
     */
    public function toggleIcon($row, $href, $label, $title, $icon, $attributes)
    {
        if (Contao\Input::get('tid')) {
            $this->toggleVisibility(Contao\Input::get('tid'), (Contao\Input::get('state') == 1), (@func_get_arg(12) ?: null));
            $this->redirect($this->getReferer());
        }

        // Check permissions AFTER checking the tid, so hacking attempts are logged
        if (!$this->User->hasAccess('tl_css_helper_style::published', 'alexf')) {
            return '';
        }

        $href .= '&amp;tid=' . $row['id'] . '&amp;state=' . $row['published'];

        if (!$row['published']) {
            $icon = 'invisible.svg';
        }

        return '<a href="' . $this->addToUrl($href) . '" title="' . Contao\StringUtil::specialchars($title) . '"' . $attributes . '>' . Contao\Image::getHtml($icon, $label, 'data-state="' . ($row['published'] ? 1 : 0) . '"') . '</a> ';
    }

    /**
     * published/enable a user group
     *
     * @param integer              $intId
     * @param boolean              $blnVisible
     * @param Contao\DataContainer $dc
     *
     * @throws Contao\CoreBundle\Exception\AccessDeniedException
     */
    public function toggleVisibility($intId, $blnVisible, Contao\DataContainer $dc=null)
    {

        // Set the ID and action
        Contao\Input::setGet('id', $intId);
        Contao\Input::setGet('act', 'toggle');

        if ($dc) {
            $dc->id = $intId; // see #8043
        }

        // Trigger the onload_callback
        if (isset($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onload_callback']) && is_array($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onload_callback']))
        {
            foreach ($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onload_callback'] as $callback)
            {
                if (is_array($callback))
                {
                    $this->import($callback[0]);
                    $this->{$callback[0]}->{$callback[1]}($dc);
                }
                elseif (is_callable($callback))
                {
                    $callback($dc);
                }
            }
        }

        // Check the field access
        if (!$this->User->hasAccess('tl_css_helper_style::published', 'alexf')) {
            throw new Contao\CoreBundle\Exception\AccessDeniedException('Not enough permissions to activate/deactivate css helper stlye ID ' . $intId . '.');
        }

        // Set the current record
        if ($dc)
        {
            $objRow = $this->Database->prepare("SELECT * FROM tl_css_helper_style WHERE id=?")
                                     ->limit(1)
                                     ->execute($intId);

            if ($objRow->numRows)
            {
                $dc->activeRecord = $objRow;
            }
        }

        $objVersions = new Contao\Versions('tl_css_helper_style', $intId);
        $objVersions->initialize();

        // Reverse the logic (members have published=1)
        // $blnVisible = !$blnVisible;

        // Trigger the save_callback
        if (isset($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['save_callback']) && is_array($GLOBALS['TL_DCA']['tl_css_helper_style']['fields']['published']['save_callback']))
        {
            foreach ($GLOBALS['TL_DCA']['tl_css_helper_style']['fields']['published']['save_callback'] as $callback)
            {
                if (is_array($callback))
                {
                    $this->import($callback[0]);
                    $blnVisible = $this->{$callback[0]}->{$callback[1]}($blnVisible, $dc);
                }
                elseif (is_callable($callback))
                {
                    $blnVisible = $callback($blnVisible, $dc);
                }
            }
        }

        $time = time();

        // Update the database
        $this->Database->prepare("UPDATE tl_css_helper_style SET tstamp=$time, published='" . ($blnVisible ? '1' : '') . "' WHERE id=?")
                       ->execute($intId);

        if ($dc)
        {
            $dc->activeRecord->tstamp = $time;
            $dc->activeRecord->published = ($blnVisible ? '1' : '');
        }

        // Trigger the onsubmit_callback
        if (isset($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onsubmit_callback']) && is_array($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onsubmit_callback']))
        {
            foreach ($GLOBALS['TL_DCA']['tl_css_helper_style']['config']['onsubmit_callback'] as $callback)
            {
                if (is_array($callback))
                {
                    $this->import($callback[0]);
                    $this->{$callback[0]}->{$callback[1]}($dc);
                }
                elseif (is_callable($callback))
                {
                    $callback($dc);
                }
            }
        }

        $objVersions->create();
    }

    public function listArticles($arrRow)
    {
        $label = '';
        $label .= '<div class="tl_content_left tl_css_helper_style">';
            $label .= '<strong>' . $arrRow['title'] . '</strong>';
            $label .= ' <span>[' . $arrRow['cssClasses'] . ']</span>';
        $label .= '</div>';
        return $label;
    }

    /**
     * Return all modules except profile modules
     *
     * @param Contao\DataContainer $dc
     *
     * @return array
     */
    public function getModules(Contao\DataContainer $dc)
    {
        // for now we sort them hardcoded
        $arrModules = array();
        $supportedModules = array(
            'article',
            'calendarEvent',
            'form',
            'formField',
            'layout',
            'news',
            'module',
            'page',
        );
        foreach ($supportedModules as $value) {
            $arrModules['modules'][] = $value;
        }
        return $arrModules;
    }

    /**
     * Return all content elements
     *
     * @return array
     */
    public function getContentElements()
    {
        return array_map('array_keys', $GLOBALS['TL_CTE']);
    }
}